package com.webtako.flash {	
	import caurina.transitions.Tweener;
	
	import flash.display.CapsStyle;
	import flash.display.JointStyle;
	import flash.display.LineScaleMode;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.AntiAliasType;
	import flash.text.StyleSheet;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.Timer;
	
	public class BannerRotator extends Sprite {
		public static const TEXT_FONT:MyFont = new MyFont();
		public static const ALIGN_TOP:String = "TOP";
		public static const ALIGN_BOTTOM:String = "BOTTOM";
		public static const PANEL_ALPHA:Number = 0.75;
		public static const TRANSITION_TYPE:String = "easeOutQuart";
		public static const TRANSITION_TIME:Number = 1.0;
		public static const TOP_LEFT:String     = "TL";
		public static const TOP_RIGHT:String    = "TR";
		public static const BOTTOM_LEFT:String  = "BL";
		public static const BOTTOM_RIGHT:String = "BR";		
		public static const MIN_CONTENT_SIZE:Number = 10;
		
		private var _slide:Slide;		
		private var _thumbnails:Array;		
		private var _fwdButton:DirectionalButton;
		private var _backButton:DirectionalButton;
		private var _playPauseButton:PlayPauseButton;
		private var _clock:Clock;	
		private var _controlPanel:Sprite;		
		private var _topPane:Sprite;		
		private var _prevIndex:Number;
		private var _currentIndex:Number;
		private var _dataPath:String;
		private var _mouseout:Boolean;
		
		private var _thumbSize:Number;
		private var _slideWidth:Number;
		private var _slideHeight:Number;	
		private var _gap:Number;	
		private var _btnSize:Number;					
		private var _timer:Timer;
		private var _delay:Number;
		private var _autoStart:Boolean;
		private var _cpanelAlign:String;
		private var _description:String;
		private var _mouseoverTextPanel:Boolean;
		private var _textField:TextField;
		private var _textPanel:Sprite;
		private var _textPanelY:Number;		
		private var _textPanelOffset:Number;	
		private var _textpanelAlign:String;	
		private var _textMargin:Number;
				
		private var _displayClock:Boolean;
		private var _displayDButtons:Boolean;
		private var _displayPlayPauseButton:Boolean;
		private var _displayThumbnails:Boolean;
		private var _displayTextPanel:Boolean;
		private var _displayTooltip:Boolean;
		private var _mouseoverDButtons:Boolean;
		
		private var _styleSheet:StyleSheet;
		private var _thumbData:XMLList;
		private var _tooltipData:XMLList;
		
		private var _stageReady:Boolean;
		
		public function BannerRotator(configPath:String = "config.xml", dataPath:String = "data.xml", cssPath:String = "") {	
			this._dataPath = dataPath;
			this._thumbnails = new Array();				
			this._mouseout = true;
			this._currentIndex = 0;
			this._stageReady = false;
			
			//add event listeners
			this.addEventListener(MouseEvent.MOUSE_OVER, onMouseover);
			this.addEventListener(MouseEvent.MOUSE_OUT, onMouseout);
			this.addEventListener(Event.ADDED_TO_STAGE, stageReady);
			
			//load config xml
			var configLoader:URLLoader = new URLLoader();
			configLoader.addEventListener(Event.COMPLETE, processConfigXML); 
			configLoader.addEventListener(IOErrorEvent.IO_ERROR, ioError);
			configLoader.load(new URLRequest(configPath));
			
			if (cssPath && cssPath != "") {
				var cssLoader:URLLoader = new URLLoader();
		        cssLoader.addEventListener(Event.COMPLETE, processCSS);
		        cssLoader.addEventListener(IOErrorEvent.IO_ERROR, ioError);
	    	   	cssLoader.load(new URLRequest(cssPath));		 
	  		}
		}
		
		//process config xml
		private function processConfigXML(event:Event):void {
			var loader:URLLoader = URLLoader(event.currentTarget);
			
			if (loader.data) {
				//set global properties
				var globalData:XML  = 		 new XML(loader.data);
				this._delay = 				 FlashUtil.getNumberParam(globalData.@delay, 5);
				this._autoStart =		     FlashUtil.getBooleanParam(globalData.@autoStart, true);	
				this._slideWidth =	 		 FlashUtil.getNumberParam(globalData.@width, 590);
				this._slideHeight =	 		 FlashUtil.getNumberParam(globalData.@height, 300);	
				this._gap = 			 	 FlashUtil.getNumberParam(globalData.@gap, 1);										
				var transitionType:String =  FlashUtil.getStringParam(globalData.@transitionType, Slide.FADE_TRANSITION);	
				var bgColor:uint = 		 	 FlashUtil.getUintParam(globalData.@bgColor, 0x000000);								
				var displayBorder:Boolean =  FlashUtil.getBooleanParam(globalData.@displayBorder, false);	
				var borderColor:uint =		 FlashUtil.getUintParam(globalData.@borderColor, 0x000000);										
				this._cpanelAlign =			 FlashUtil.getStringParam(globalData.@thumbnailsAlign, BOTTOM_RIGHT);				
				this._displayClock =		 	FlashUtil.getBooleanParam(globalData.@displayClock, true);		
				this._displayDButtons = 		FlashUtil.getBooleanParam(globalData.@displayDirectionalButtons, true);
				this._displayPlayPauseButton = 	FlashUtil.getBooleanParam(globalData.@displayPlayPauseButton, true);		
				this._displayThumbnails =	 	FlashUtil.getBooleanParam(globalData.@displayThumbButtons, true);	
				this._mouseoverDButtons = 		FlashUtil.getBooleanParam(globalData.@mouseoverDirectionalButtons, true);

				//set preloader properties
				var preloaderData:XMLList =  	globalData.preloader;
				var preloaderSize:Number = 	 	FlashUtil.getNumberParam(preloaderData.@size, 28);		
				var preloaderColor:uint =	 	FlashUtil.getUintParam(preloaderData.@color, 0x0066FF);
				var preloaderTextSize:Number = 	FlashUtil.getNumberParam(preloaderData.@textSize, 10);	
				var preloaderTextColor:uint =	FlashUtil.getUintParam(preloaderData.@textColor, 0xFFFFFF);
				
				//set button properties
				var buttonData:XMLList =   		globalData.button;
				this._btnSize	= 	  			FlashUtil.getNumberParam(buttonData.@size, 28);	
				var btnShape:String	=			FlashUtil.getStringParam(buttonData.@shape, PlayPauseButton.ROUND_SQUARE);
				var btnColor:uint = 	   		FlashUtil.getUintParam(buttonData.@color, 0xFFFFFF);
				var btnMouseoverColor:uint = 	FlashUtil.getUintParam(buttonData.@mouseoverColor, 0x0066FF);				
				var btnBgColor:uint = 			FlashUtil.getUintParam(buttonData.@bgColor, 0x000000);
				var btnAlpha:Number =			FlashUtil.getBooleanParam(buttonData.@semiTransparent, true) ? PANEL_ALPHA : 1;
				
				//set text panel properties
				var textpanelData:XMLList = 	globalData.textpanel;
				var textSize:Number =		 	FlashUtil.getNumberParam(textpanelData.@textSize, 12);
				var textColor:uint =		 	FlashUtil.getUintParam(textpanelData.@textColor, 0xFFFFFF);
				var textpanelBgColor:uint =	 	FlashUtil.getUintParam(textpanelData.@bgColor, 0x000000);
				var textpanelAlpha:Number =	 	FlashUtil.getBooleanParam(textpanelData.@semiTransparent, true) ? PANEL_ALPHA : 1;
				this._displayTextPanel =  		FlashUtil.getBooleanParam(textpanelData.@display, true);
				this._mouseoverTextPanel = 	 	FlashUtil.getBooleanParam(textpanelData.@mouseover, false);		
				this._textMargin =				FlashUtil.getNumberParam(textpanelData.@margin, 5);
					
				//set thumbnail properties
				this._thumbData = globalData.thumbnail;				
				this._thumbSize =  				FlashUtil.getNumberParam(this._thumbData.@size, 28);
			
				//set tooltip properties
				this._tooltipData = globalData.tooltip;				
				
				//convert delay time
				if (this._delay < 1) {
					this._delay = 5;
				}
				this._delay *= 1000;
				 
				//set text panel alignment
				if (this._cpanelAlign == BOTTOM_LEFT || this._cpanelAlign == BOTTOM_RIGHT) {
					this._textpanelAlign = ALIGN_TOP;
				}
				else {
					this._textpanelAlign = ALIGN_BOTTOM;
				}
				
				//size check			
				if (this._thumbSize < MIN_CONTENT_SIZE) {
					this._thumbSize = MIN_CONTENT_SIZE;
				}

				if (this._slideWidth < MIN_CONTENT_SIZE) {
					this._slideWidth = MIN_CONTENT_SIZE;
				}

				if (this._slideHeight < MIN_CONTENT_SIZE) {
					this._slideHeight = MIN_CONTENT_SIZE;
				}
				
				if (this._gap < 0) {
					this._gap = 0;
				}
				
				//init top pane
				this._topPane = new Sprite();
				this._topPane.graphics.beginFill(0x000000, 0);
				this._topPane.graphics.drawRect(0, 0, this._slideWidth, this._slideHeight);
				this._topPane.graphics.endFill();
				this._topPane.mouseEnabled = false;	
				this._topPane.mouseChildren = true;
				this._topPane.alpha = 0;
				this._topPane.visible = false;
				this.addMask(this._topPane);
				
				//init play/pause button				
				this._playPauseButton = new PlayPauseButton(!this._autoStart, btnColor, btnMouseoverColor, 
															btnBgColor, btnAlpha, this._btnSize, btnShape);
				this._playPauseButton.addEventListener(MouseEvent.CLICK, playPause);		
				
				//init timer clock
				this._clock = new Clock(this._delay, Math.round(this._btnSize/2), btnColor, btnBgColor, btnAlpha);

				//init text panel
				this.initTextPanel(textSize, textColor, textpanelBgColor, textpanelAlpha);
				
				//init directional buttons
				this.initDirectionalButtons(btnColor, btnMouseoverColor, btnBgColor, btnAlpha, btnShape);
				
				//init frame
				if (displayBorder) {
					this.initFrame(borderColor);
				}
				
				//init main slide
				this._slide = new Slide(transitionType, this._slideWidth, this._slideHeight, bgColor, 
										preloaderColor, preloaderSize, preloaderTextSize, preloaderTextColor);										
				this._slide.addEventListener(Slide.CONTENTS_LOADED, loadingComplete);
				this._slide.addEventListener(Slide.CONTENT_CHANGE,  updatePanelText);
				this.addChild(this._slide);			

				//add top pane				
				this.addChild(this._topPane);
				
				//init rotate timer
				this._timer = new Timer(this._delay, 1);
				this._timer.addEventListener(TimerEvent.TIMER, rotate);
		
				//load data xml
				var dataLoader:URLLoader = new URLLoader(); 
				dataLoader.addEventListener(Event.COMPLETE, processDataXML); 	
				dataLoader.addEventListener(IOErrorEvent.IO_ERROR, ioError);			
				dataLoader.load(new URLRequest(this._dataPath));	
			}	
			else {
				trace("No Config Data");
			}
		}
		
		//process data xml
		private function processDataXML(event:Event):void {
			var loader:URLLoader = URLLoader(event.currentTarget);
			if (loader.data) {	
				var xmlData:XML = XML(loader.data);					
				var slideList:XMLList = xmlData.slide;
				
				if (slideList.length() == 0) {
					trace("No Slide Data");
					return;
				}
				
				//init control panel	
				this._controlPanel = new Sprite();
				this._controlPanel.cacheAsBitmap = true;
				
				//init each slide and create thumbnail
				var xOffset:Number = 0;
				var yOffset:Number = 0;
				var cpanelWidth:Number = Math.round(this._slideWidth - (2 * this._gap));				
				var tooltipAlign:String = this.getTooltipAlign();
				
				var thumbShape:String =			FlashUtil.getStringParam(this._thumbData.@shape, Thumbnail.SQUARE);	
				var thumbTextSize:Number =		FlashUtil.getNumberParam(this._thumbData.@textSize, 12);
				var thumbColor:uint =			FlashUtil.getUintParam(this._thumbData.@color, 0xFFFFFF);			
				var thumbHoverColor:uint = 		FlashUtil.getUintParam(this._thumbData.@mouseoverColor, 0x000000);		
				var thumbBgColor:uint =			FlashUtil.getUintParam(this._thumbData.@bgColor, 0x000000);	
				var thumbHoverBgColor:uint =	FlashUtil.getUintParam(this._thumbData.@mouseoverBgColor, 0xFFFFFF);		
				var thumbFrameColor:uint = 		FlashUtil.getUintParam(this._thumbData.@borderColor, 0x333333);		
				var thumbHoverFrameColor:uint =	FlashUtil.getUintParam(this._thumbData.@mouseoverBorderColor, 0x0066FF);	
				var displayThumbImage:Boolean =	FlashUtil.getBooleanParam(this._thumbData.@displayImage, true);		
				var displayThumbBorder:Boolean =FlashUtil.getBooleanParam(this._thumbData.@displayBorder, true);		
				this._thumbData = null;
				
				this._displayTooltip =				FlashUtil.getBooleanParam(this._tooltipData.@display, true);
				var tooltipTextSize:Number =  		FlashUtil.getNumberParam(this._tooltipData.@textSize, 12);
				var tooltipTextColor:uint = 		FlashUtil.getUintParam(this._tooltipData.@textColor, 0xFFFFFF);		
				var tooltipBgColor:uint =			FlashUtil.getUintParam(this._tooltipData.@bgColor, 0x000000);			
				var tooltipRoundCorners:Boolean =	FlashUtil.getBooleanParam(this._tooltipData.@roundCorners, false);									
				var tooltipAlpha:Number =			FlashUtil.getBooleanParam(this._tooltipData.@semiTransparent, true) ? PANEL_ALPHA : 1;
				
				this._tooltipData = null;
							
				for each (var item:XML in xmlData.slide) {		
					var thumbPath:String = item.@thumbPath;
					var extPath:String =  item.@path;					
					var caption:String = item.caption;					
					var description:String = item.description;					
					var link:String = item.@link;
					var target:String = FlashUtil.getStringParam(item.@target, "_blank");
					
					var thumbnail:Thumbnail = new Thumbnail(item.childIndex(), caption, description, thumbPath, link, target,  
												this._thumbSize, thumbTextSize, thumbColor, thumbHoverColor, 
												thumbBgColor, thumbHoverBgColor, thumbFrameColor, thumbHoverFrameColor, 
												displayThumbImage, displayThumbBorder, thumbShape, tooltipAlign,
												tooltipTextSize, tooltipTextColor, tooltipBgColor, 
												tooltipAlpha, tooltipRoundCorners);
					thumbnail.addEventListener(Thumbnail.THUMB_LOADED, loadNextThumbnail);
					thumbnail.addEventListener(MouseEvent.CLICK, thumbnailClick);
					
					if (this._displayThumbnails) {
						if (xOffset + this._thumbSize > cpanelWidth) {
							xOffset = 0;
							yOffset += this._thumbSize + this._gap;
						}
			
						thumbnail.x = xOffset;
						thumbnail.y = yOffset;
						this._controlPanel.addChild(thumbnail);						
						xOffset += (this._thumbSize + this._gap);	
					}
					
					this._thumbnails.push(thumbnail);							
					this._slide.addPath(extPath);
				}
				
				if (this._displayThumbnails && this._displayTooltip) {
					if (this._stageReady) {
						this.addTooltips();
					}
					else {
						var timer:Timer = new Timer(100);
						timer.addEventListener(TimerEvent.TIMER, checkStage);
						timer.start();
					}
				}
				
				var buttonPanel:Sprite = new Sprite();
				var buttonXOffset:Number = 0;
				
				//add back button
				if (!this._mouseoverDButtons && this._displayDButtons) {
					this._backButton.x = buttonXOffset;
					buttonPanel.addChild(this._backButton);
					buttonXOffset += this._btnSize + this._gap;
				}
				
				//add play/pause button
				if (this._displayPlayPauseButton) {
					this._playPauseButton.x = buttonXOffset;
					buttonPanel.addChild(this._playPauseButton);
					buttonXOffset += this._btnSize + this._gap;
				}
				
				//add fwd button
				if (!this._mouseoverDButtons && this._displayDButtons) {
					this._fwdButton.x = buttonXOffset;	
					buttonPanel.addChild(this._fwdButton);
					buttonXOffset += this._btnSize + this._gap;	
				}
				
				//add timer clock		
				if (this._displayClock) {		
					this._clock.x = buttonXOffset + this._clock.radius;
					this._clock.y = this._clock.radius;
					buttonPanel.addChild(this._clock);			  			
				}
				
				if (xOffset + buttonPanel.width <= cpanelWidth) {
					buttonPanel.x = xOffset;
					buttonPanel.y = yOffset;
				}
				else {
					buttonPanel.x = 0;
					buttonPanel.y = this._thumbSize + this._gap;	
				}					
				this._controlPanel.addChild(buttonPanel);
					
				//set control panel fill size
				this._controlPanel.graphics.beginFill(0x000000, 0);
				this._controlPanel.graphics.drawRect(0, 0, this._controlPanel.width, this._controlPanel.height);
				this._controlPanel.graphics.endFill();	
				
				//align & add control panel
				switch (this._cpanelAlign) {
				    case TOP_LEFT:
				    	this._controlPanel.x = this._gap;
				    	this._controlPanel.y = this._gap;
				        break;
				    case TOP_RIGHT:
				    	this._controlPanel.x = this._slideWidth - (this._controlPanel.width + this._gap);
				    	this._controlPanel.y = this._gap;				
				        break;
				    case BOTTOM_LEFT:
				    	this._controlPanel.x = this._gap;
				    	this._controlPanel.y = this._slideHeight - (this._controlPanel.height + this._gap);	
				        break;
				    default:
				    	this._controlPanel.x = this._slideWidth - (this._controlPanel.width + this._gap);
				    	this._controlPanel.y = this._slideHeight - (this._controlPanel.height + this._gap);	
				}
				this._topPane.addChild(this._controlPanel);		
				
				//start content load
				this.startContentLoad();	
			}
			else {
				trace("No Data");
			}	
		}	
		
		//process css stylesheet
		private function processCSS(event:Event):void {
			var cssText:String = URLLoader(event.currentTarget).data;
			if (cssText) {
				this._styleSheet = new StyleSheet();
    	  		this._styleSheet.parseCSS(cssText);     
   			}
   			else {
   				trace("No CSS Data");
   			}
		}
		
		//add mask
		private function addMask(obj:Sprite):void {
			var maskSprite:Sprite = new Sprite();			
			maskSprite.graphics.beginFill(0x000000);
			maskSprite.graphics.drawRect(0, 0, obj.width, obj.height);
			maskSprite.graphics.endFill();
			
			obj.mask = maskSprite;	
			obj.addChild(maskSprite);
		}
		
		//init frame
		private function initFrame(color:uint):void {
			var frame:Shape = new Shape();
			frame.graphics.lineStyle(1, color, 1.0, true, LineScaleMode.NORMAL, CapsStyle.SQUARE, JointStyle.MITER);
			frame.graphics.drawRect(0, 0, this._slideWidth - 1, this._slideHeight - 1);
			this._topPane.addChild(frame);	
		}
		
		//init directional buttons
		private function initDirectionalButtons(color:uint, mouseoverColor:uint, bgColor:uint, bgAlpha:Number, shape:String):void {
			//init back button 
			this._backButton = new DirectionalButton(DirectionalButton.BACK, color, mouseoverColor, 
													 bgColor, bgAlpha, this._btnSize, shape);		
			this._backButton.addEventListener(MouseEvent.CLICK, moveSlideBack);			
			
			//init forward button 
			this._fwdButton = new DirectionalButton(DirectionalButton.FORWARD, color, mouseoverColor, 
													bgColor, bgAlpha, this._btnSize, shape);			
			this._fwdButton.addEventListener(MouseEvent.CLICK, moveSlideFwd);						
					
			if (this._mouseoverDButtons && this._displayDButtons) {
				this._backButton.x = -this._backButton.width;
				this._backButton.y = Math.round((this._slideHeight - this._backButton.height)/2);
				this._topPane.addChild(this._backButton);
				
				this._fwdButton.x = this._slideWidth;
				this._fwdButton.y = Math.round((this._slideHeight - this._fwdButton.height)/2);			
				this._topPane.addChild(this._fwdButton);
			}
		}
		
		//init text panel
		private function initTextPanel(textSize:Number, textColor:uint, bgColor:uint, bgAlpha:Number):void {
			//init text format
			var textFormat:TextFormat = new TextFormat();
			textFormat.font = TEXT_FONT.fontName;
			textFormat.size = textSize;
			textFormat.color = textColor;	
			
			//init text field
			this._textField = new TextField();
			this._textField.defaultTextFormat = textFormat;
			this._textField.autoSize = TextFieldAutoSize.LEFT;
			this._textField.selectable = false;
			this._textField.multiline = true;			
			this._textField.wordWrap = true;										
			this._textField.condenseWhite = true;
			this._textField.embedFonts = true;
			this._textField.antiAliasType = AntiAliasType.ADVANCED;				
			this._textField.width = this._slideWidth - (2 * this._textMargin);
			this._textField.htmlText = "";
			
			//init text panel to hold text field
			this._textPanel = new Sprite();
			this._textPanel.graphics.beginFill(bgColor, bgAlpha);
			this._textPanel.graphics.drawRect(0, 0, this._slideWidth, this._slideHeight);
			this._textPanel.graphics.endFill();		
			
			if (this._textpanelAlign == ALIGN_TOP) {			
				this._textPanel.y = this._textPanelOffset = -this._slideHeight;
			}	
			else {
				this._textField.y = this._textMargin;
				this._textPanel.y = this._textPanelOffset = this._slideHeight;		
			}
			
			if (this._displayTextPanel) {
				this._topPane.addChild(this._textPanel);								
			}
		}
		
		//set main panel text 
		public function updatePanelText(event:Event):void {
			var margin:Number = this._textMargin;
			
			//remove previous text field
			if (this._textPanel.contains(this._textField)) {		
				this._textPanel.removeChild(this._textField);
			}
			
			//init text field
			if (this._styleSheet) {
				this._textField.styleSheet = this._styleSheet;
			}
			this._textField.htmlText = this._description;
			this._textField.autoSize = TextFieldAutoSize.LEFT;		
		
			if (this._description == "") {
				this._textField.autoSize = TextFieldAutoSize.NONE;
				this._textField.height = 0;	
				margin = 0;
			}
			else if (this._textField.height + (2 * margin) > this._slideHeight) {
				this._textField.autoSize = TextFieldAutoSize.NONE;
				this._textField.height = this._slideHeight - (2 * margin);
			}
			
			if (this._textpanelAlign == ALIGN_TOP) {			
				this._textField.y = this._slideHeight - (this._textField.height + margin);	
				this._textPanelY = this._textPanelOffset + (this._textField.height + (2 * margin));	
			}
			else {
				this._textPanelY = this._textPanelOffset - (this._textField.height + (2 * margin));	
			}	
			this._textField.x = margin;
			this._textField.alpha = 0;		
			this._textPanel.addChild(this._textField);	
				
			if (this._mouseoverTextPanel && this._mouseout) {
				Tweener.addTween(this._textPanel, {y:this._textPanelOffset, time:TRANSITION_TIME, transition:TRANSITION_TYPE, onComplete:fadeinText, onOverwrite:fadeinText});			
			}
			else {
				Tweener.addTween(this._textPanel, {y:this._textPanelY, time:TRANSITION_TIME, transition:TRANSITION_TYPE, onComplete:fadeinText, onOverwrite:fadeinText});
			}
		}
		
		// fade in panel's text
		private function fadeinText():void {
			Tweener.addTween(this._textField, {alpha:1, time:0.5, transition:TRANSITION_TYPE});	
		}

		//start loading process
		private function startContentLoad():void {
			this._currentIndex = 0;
			if (this._currentIndex < this._thumbnails.length) {
				this._thumbnails[this._currentIndex].loadContent();	
			}	
		}
		
		//load next thumbnail event handler
		private function loadNextThumbnail(event:Event):void {
			this._currentIndex++;
			if (this._currentIndex < this._thumbnails.length) {
				this._thumbnails[this._currentIndex].loadContent();					
			}
			else {
				this._slide.loadAllContent();
			}
		}
		
		//loading complete
		private function loadingComplete(event:Event):void {				
			//display content
			this._prevIndex = -1;
			this._currentIndex = 0;
			this.displayContent();
				
			//enable top pane
			Tweener.addTween(this._topPane, {alpha:1,time:0.5, transition:TRANSITION_TYPE, onStart:setTopPaneVisible});	
								
			//start timer
			if (this._autoStart) {				
				this._clock.start();
				this._timer.start();		
			}	
		}
		
		//back button event handler
		private function moveSlideBack(event:MouseEvent):void {						
			event.stopPropagation();

			//stop timer
			this.stopTimer();
					
			//set indexes
			this._prevIndex = this._currentIndex;		
			if (this._currentIndex > 0) {
				this._currentIndex--;
			}
			else {
				this._currentIndex = this._thumbnails.length - 1;
			}	
			//display content
			this.displayContent();		
			
			//start timer
			this.startTimer();				
		}
		
		// fwd button event handler
		private function moveSlideFwd(event:MouseEvent):void {
			event.stopPropagation();
			
			//stop timer
			this.stopTimer();
			
			//set indexes
			this._prevIndex = this._currentIndex;
			if (this._currentIndex + 1 < this._thumbnails.length) {
				this._currentIndex++;
			}
			else {
				this._currentIndex = 0;
			}
			//display content
			this.displayContent();	
			
			//start timer
			this.startTimer();	
		}
		
		// thumbnail click event handler
		private function thumbnailClick(event:MouseEvent):void {
			event.stopPropagation();
			
			//stop timer
			this.stopTimer();
				
			var thumbnail:Thumbnail = Thumbnail(event.currentTarget);			
			//set indexes
			this._prevIndex = this._currentIndex;
			this._currentIndex = thumbnail.index;

			//display selected content
			this.displayContent();	
			
			//start timer
			this.startTimer();	
		}	
		
		// play/pause button event handler
		private function playPause(event:MouseEvent):void {					
			event.stopPropagation();
			
			if (this._playPauseButton.playMode) {	
				//play
				this._timer.reset();	
				this._timer.delay = this._delay - this._clock.elapseTime;
				
				this._clock.resume();	
				this._timer.start();			
			}
			else {	
				//pause
				this._timer.stop();
				this._clock.pause();
			}
			//switch symbol
			this._playPauseButton.toggleDisplay();			
		}
		
		// timer rotate event handler		
		private function rotate(event:TimerEvent):void {
			//stop clock
			this._clock.stop();
			
			//set indexes
			this._prevIndex = this._currentIndex;
			if (this._currentIndex + 1 < this._thumbnails.length) {
				this._currentIndex++;
			}
			else {
				this._currentIndex = 0;
			}
			//display content
			this.displayContent();	
			
			//start timer
			this.startTimer();	
		}
		
		// load main slide's content
		private function displayContent():void {
			//get current thumbnail
			var currThumbnail:Thumbnail = this._thumbnails[this._currentIndex];
			
			//assign thumbnail's data to main slide
			this._slide.link = currThumbnail.link;
			this._slide.target = currThumbnail.target;
			this._description = currThumbnail.description;
			
			//display new content
			this._slide.displayContent(currThumbnail.index);	
			
			//mark thumbnail
			var prevThumbnail:Thumbnail = this._thumbnails[this._prevIndex];
			if (prevThumbnail) {
				prevThumbnail.unhighlight();
			}	
			currThumbnail.highlight();
		}	
		
		// start timer
		private function startTimer():void {
			if (this._playPauseButton.pauseMode) {
				this._timer.reset();
				this._timer.delay = this._delay;

				this._clock.start();
				this._timer.start();	
			}
		}	
		
		// stop timer
		private function stopTimer():void {
			this._timer.stop();
			this._clock.stop();					
		}
		
		// on mouse over event handler
		private function onMouseover(event:MouseEvent):void {
			//set mouse leave flag
			this._mouseout = false;
			
			//display directional buttons
			if (this._mouseoverDButtons) {
				Tweener.addTween(this._backButton, {x:this._gap, time:0.75, transition:TRANSITION_TYPE});
				Tweener.addTween(this._fwdButton,  {x:this._slideWidth - this._fwdButton.width - this._gap, time:0.75, transition:TRANSITION_TYPE});	
			}
				
			//display text panel
			if (this._mouseoverTextPanel && this._textPanel.contains(this._textField)) {
				Tweener.addTween(this._textPanel, {y:this._textPanelY, time:TRANSITION_TIME, transition:TRANSITION_TYPE});						
			}	
		}
		
		// on mouse out event handler
		private function onMouseout(event:MouseEvent):void {
			//set mouse leave flag
			this._mouseout = true;
			
			//hide directional buttons
			if (this._mouseoverDButtons) {
				Tweener.addTween(this._backButton, {x:-this._backButton.width, time:0.75, transition:TRANSITION_TYPE});
				Tweener.addTween(this._fwdButton,  {x:this._slideWidth, time:0.75, transition:TRANSITION_TYPE});	
			}
			
			//hide text panel
			if (this._mouseoverTextPanel && this._textPanel.contains(this._textField)) {
				Tweener.addTween(this._textPanel, {y:this._textPanelOffset, time:TRANSITION_TIME, transition:TRANSITION_TYPE});						
			}
		}
		
		// get tooltip alignment
		private function getTooltipAlign():String {
			switch (this._cpanelAlign) {
				case TOP_LEFT:
					return Tooltip.BOTTOM_RIGHT;
				case TOP_RIGHT:
					return Tooltip.BOTTOM_LEFT;
				case BOTTOM_LEFT:
					return Tooltip.TOP_RIGHT;
				default:
					return Tooltip.TOP_LEFT;					
			}
		}	
		
		//set top pane to visible
		private function setTopPaneVisible():void {
			this._topPane.visible = true;	
		}	
		
		//check if stage is ready
		private function checkStage(event:TimerEvent):void {
			if (this._stageReady) {
				Timer(event.currentTarget).stop();
				this.addTooltips();
			}
		}
		
		private function ioError(event:IOErrorEvent):void {
			trace("IO Error: " + event.text);	
		}
		
		private function stageReady(event:Event):void {
			this._stageReady = true;	
		}
		
		//add tooltips
		private function addTooltips():void {
			//add thumbnail tooltip
			for (var i:uint = 0; i < this._thumbnails.length; i++) {
				var thumbnail:Thumbnail = this._thumbnails[i];
				if (thumbnail.tooltip) {
					this.stage.addChild(thumbnail.tooltip);						
				}
			}						
		}
	}
}