package com.webtako.flash {
	import caurina.transitions.Tweener;
	import caurina.transitions.properties.ColorShortcuts;
	ColorShortcuts.init();
		
	import flash.display.MovieClip;
	import flash.geom.ColorTransform;
	import flash.events.MouseEvent;
	
	public class DirectionalButton extends MovieClip {		
		public static const TRANSITION_TYPE:String = "easeOutQuart";
		public static const TRANSITION_TIME:Number = 1.0;
		public static const SQUARE:String = "SQUARE";
		public static const CIRCLE:String = "CIRCLE";
		public static const ROUND_SQUARE:String = "ROUND_SQUARE";	
		public static const DEFAULT_SIZE:Number = 28;	
		public static const BACK:String = "BACK";
		public static const FORWARD:String = "FORWARD";
		
		private var _arrow:MovieClip;
		private var _container:MovieClip;
		private var _color:uint;
		private var _mouseoverColor:uint;
		
		public function DirectionalButton(directionType:String = FORWARD, 
								color:uint = 0xFFFFFF, mouseoverColor:uint = 0x0066FF, 
								bgColor:uint = 0x000000, bgAlpha:Number = 0.5, 
								buttonSize:Number = DEFAULT_SIZE, containerType:String = CIRCLE) {
			//assign properties						
			this._color = color;
			this._mouseoverColor = mouseoverColor;					
			
			//set size
			var scalePct = (buttonSize/this.width);  
			this.scaleX = scalePct;
			this.scaleY = scalePct; 
			
			//set container type
			containerType = containerType.toUpperCase();
			switch (containerType) {
				case SQUARE:
					this._container = this.square;
					this.rsquare.visible = false;
					this.circle.visible = false;
					break;
				case ROUND_SQUARE:
					this._container = this.rsquare;
					this.square.visible = false;
					this.circle.visible = false;
					break;
				default:
					this._container = this.circle;
					this.square.visible = false;
					this.rsquare.visible = false;
			}
			
			//set background color
			var colorTransform:ColorTransform = this._container.transform.colorTransform;
			colorTransform.color = bgColor;
			this._container.transform.colorTransform = colorTransform;			
			this._container.alpha = bgAlpha;

			//set arrow type
			directionType = directionType.toUpperCase();			
			if (directionType == BACK) {
				this.fwdArrow.visible = false;	
				this._arrow = this.backArrow;
			}
			else {
				this.backArrow.visible = false;
				this._arrow = this.fwdArrow;				
			}
			
			//set arrow color
			colorTransform = this._arrow.transform.colorTransform;
			colorTransform.color = this._color
			this._arrow.transform.colorTransform = colorTransform;
			
			//init mouse behavior			
			this.buttonMode = true;
			this.useHandCursor = true;	
			this.mouseChildren = false;
			
			this.addEventListener(MouseEvent.MOUSE_OVER, onButtonOver);
			this.addEventListener(MouseEvent.MOUSE_OUT, onButtonOut);
		}
		
		//on mouseover event handler
		private function onButtonOver(event:MouseEvent):void {
			Tweener.addTween(this._arrow, {_color:this._mouseoverColor,time:TRANSITION_TIME, transition:TRANSITION_TYPE});		
		}
		
		//on mouseout event handler
		private function onButtonOut(event:MouseEvent):void {
			Tweener.addTween(this._arrow, {_color:this._color, time:TRANSITION_TIME, transition:TRANSITION_TYPE});				
		}
	}
}