package com.webtako.flash {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.ProgressEvent;
	import flash.geom.ColorTransform;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	public class Preloader extends Sprite {		
		public static const PADDING:Number = 4;
		public static const TEXT_FONT:MyFont = new MyFont();	
		private var _textField:TextField;
		private var _symbol:MovieClip;			
		
		public function Preloader(w:Number, h:Number, symbolSize:Number = 28, 
								color:uint = 0x0066FF, textSize:Number = 10, textColor:uint = 0xFFFFFF) {
			//init background
			this.graphics.beginFill(0x000000, 0);
			this.graphics.drawRect(0, 0, w, h);
			this.graphics.endFill();
			
			//assign symbol
			this._symbol = new PreloaderArrow();
			
			//set size
			var scalePct = (symbolSize/this._symbol.height);  
			this._symbol.scaleX = scalePct;
			this._symbol.scaleY = scalePct; 
			
			//set color
			var colorTransform:ColorTransform = this._symbol.transform.colorTransform;
			colorTransform.color = color;			
			this._symbol.transform.colorTransform = colorTransform;

			//init text format
			var textFormat:TextFormat = new TextFormat();
			textFormat.font = TEXT_FONT.fontName;
			textFormat.size = textSize;
			textFormat.color = textColor;
			textFormat.align = TextFormatAlign.CENTER;
			
			//init text field
			this._textField = new TextField();
			this._textField.defaultTextFormat = textFormat;
			this._textField.autoSize = TextFieldAutoSize.LEFT;
			this._textField.selectable = false;
			this._textField.embedFonts = true;
			this._textField.wordWrap = true;
			this._textField.width = w;
			this._textField.antiAliasType = AntiAliasType.ADVANCED;
			this._textField.text = "loading";
			
			//add preloader symbol
			this._symbol.x = Math.round((w - symbolSize)/2);
			this._symbol.y = Math.round((h - (this._symbol.height + this._textField.height + PADDING))/2);
			this.addChild(this._symbol);

			//add text field
			this._textField.x = Math.round((w - this._textField.width)/2);
			this._textField.y = this._symbol.y + this._symbol.height + PADDING;			
			this.addChild(this._textField);			
		}

		//progress handler
		public function handleProgress(event:ProgressEvent):void {
			var pct:Number = (event.bytesLoaded / event.bytesTotal);
			this._textField.text = Math.round(pct * 100) + "%";
		}
		
		//reset text
		public function reset():void {
			this._textField.text = "";	
		}
		
		//set message
		public function set message(message:String):void {
			this._textField.text = message;
		}
		
		public function setComplete():void {
			this.message = "complete";
			this._symbol.stop();
		}
	}
}